workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == "master"

stages:
  - setup
  - test
  - build
  - deploy
   
cache:
  key:
    files:
      - package-lock.json
  policy: pull
  paths:
    - node_modules/

install_dependencies:
  image: node:14-alpine
  stage: setup
  script:
    - npm ci --unsafe-perm
    - npx ngcc --properties es2015 browser module main
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - node_modules/
  rules:
    - changes:
        - package-lock.json
    - exists:
        - node_modules
      when: never
    - when: always

test_app:
  stage: test
  image: zenika/alpine-chrome:89-with-node-14
  tags:
    - docker
  script:
    - export CHROME_BIN="chromium-browser"
    - npx ng lint
    - npx ng test --code-coverage --watch=false
  coverage: '/Statements\s+:\s\d+.\d+%/'
  artifacts:
    name: "tests-and-coverage"
    reports:
      junit:
        - dist/tests/junit-test-results.xml
      coverage_report:
        coverage_format: cobertura
        path: dist/coverage/cobertura-coverage.xml
    
build_app:
  stage: build
  image: node:14-alpine
  tags:
    - docker
  script:
    - npx ng build --configuration=cd_production_it
  artifacts:
    name: "petmenu-angular"
    paths:
      - dist

pages:
  stage: deploy
  script:
    - mv dist/cd_prod $CI_PROJECT_DIR/public
  artifacts:
    paths:
      - public
  dependencies:
    - build_app
   